--[[ Set Object Visible 
Author:    t0xic0m
Datum:    16.04.2016
Version:    1
]]

SetVisibleObject = {};

function SetVisibleObject.prerequisitesPresent(specializations) 
    return true;
end; 

function SetVisibleObject:load(savegame)
    self.VisibleObject0 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.SetVisibleObject.VisibleObject0#index"));
    self.VisibleObject1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.SetVisibleObject.VisibleObject1#index"));
    self.VisibleObject2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.SetVisibleObject.VisibleObject2#index"));
    self.VisibleObject3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.SetVisibleObject.VisibleObject3#index"));
    
    self.isObjectVisible = true;
    self.isObjectVisiblePart2 = true;
end;

function SetVisibleObject:delete()
end;

function SetVisibleObject:mouseEvent(posX, posY, isDown, isUp, button)
end;

function SetVisibleObject:keyEvent(unicode, sym, modifier, isDown)
end;

function SetVisibleObject:update(dt)
    if self:getIsActiveForInput(true) then
        if InputBinding.hasEvent(InputBinding.OBJECT_VISIBLE_INPUT_BUTTON_PART_ONE) then
            self.isObjectVisible = (not self.isObjectVisible);
        end;
        
        if InputBinding.hasEvent(InputBinding.OBJECT_VISIBLE_INPUT_BUTTON_PART_TWO) then
            self.isObjectVisiblePart2 = (not self.isObjectVisiblePart2);
        end;
            
        if self.isObjectVisible == true then
            setVisibility (self.VisibleObject0, true)
        elseif self.isObjectVisible == false then
            setVisibility (self.VisibleObject0, false)
        end;
        if self.isObjectVisible == true then
            setVisibility (self.VisibleObject1, true)
        elseif self.isObjectVisible == false then
            setVisibility (self.VisibleObject1, false)
        end;
        if self.isObjectVisiblePart2 == true then
            setVisibility (self.VisibleObject2, true)
        elseif self.isObjectVisiblePart2 == false then
            setVisibility (self.VisibleObject2, false)
        end;
        if self.isObjectVisiblePart2 == true then
            setVisibility (self.VisibleObject3, true)
        elseif self.isObjectVisiblePart2 == false then
            setVisibility (self.VisibleObject3, false)
        end;
    end;
end;


function SetVisibleObject:updateTick(dt)
end;

local function L(name)
    return g_i18n:hasText("OBJECT_VISIBLE_INPUT_"..name) and g_i18n:getText("OBJECT_VISIBLE_INPUT_"..name) or name;
end

local function K(name)
    return g_i18n:hasText("OBJECT_VISIBLE_INPUT_"..name) and g_i18n:getText("OBJECT_VISIBLE_INPUT_"..name) or name;
end

function SetVisibleObject:draw()
    if self.isClient and self:getIsActiveForInput() then
        if self.isObjectVisible then
            g_currentMission:addHelpButtonText(L("OFF_PART1"), InputBinding.OBJECT_VISIBLE_INPUT_BUTTON_PART_ONE);
        else
            g_currentMission:addHelpButtonText(L("ON_PART1"), InputBinding.OBJECT_VISIBLE_INPUT_BUTTON_PART_ONE);
        end
        
        if self.isObjectVisiblePart2 then
            g_currentMission:addHelpButtonText(K("OFF_PART2"), InputBinding.OBJECT_VISIBLE_INPUT_BUTTON_PART_TWO);
        else
            g_currentMission:addHelpButtonText(K("ON_PART2"), InputBinding.OBJECT_VISIBLE_INPUT_BUTTON_PART_TWO);
        end
    end;
end;