-- by modelleicher
-- June 2016
-- www.schwabenmodding.de
-- facebook.de/modelleicher
-- ideas and motivation: Maxter

-- Purpse:
-- Just Winching trees of course! According to the many PM's I got over the last few weeks from people asking to get this script, behaving like this
-- thing could also save the world or something like that, one might assume this is something special.
-- But I can assure you it only does winch trees. (Really, People! Get a life.. FS isn't everything, and waiting a few weeks for a mod isn't so bad)

-- Version 1.1, still Fs15, few minor bug fixes
-- Version 1.2, rotation animation for reel added
-- Version 1.3, FS17 conversion - crashing when tree is deleted fixed
-- Version 1.4, bugfixes, german language added.
-- Version 1.5, MP Fix 29-01-2017 - all tree attachers in the same table within "self" 
-- Version 1.6, Game crash during reset or sale Hotfix

winch = {};

function winch.prerequisitesPresent(specializations)
    return true;
end;

function winch:load(savegame)

	
	-- MP fix 29.01.2017 
	-- in case the needed tables aren't setup yet, setup:
	if self.winchUtilHelper == nil then -- global winch util helper
		self.winchUtilHelper = {}; 
		self.winchUtilHelper.treeAttacher = {}; -- all tree attachers will be in this table and used from this table
		self.winchUtilHelper.treeAttacherCount = 0; -- count of all tree attachers used within this mod
	end;

	self.localWUH_W = {}; -- local winch util helper
	self.localWUH_W.treeAttacherCountMin = self.winchUtilHelper.treeAttacherCount +1;


    --self.searchTrigger = winch.searchTrigger;
    self.onOff2 = winch.onOff2;
    self.clientServerSetWinching = winch.clientServerSetWinching;
   -- self.clientServerDetachTree = winch.clientServerDetachTree;
   -- self.clientServerAttachTree = winch.clientServerAttachTree;
    --self.createFinderShape = winch.createFinderShape;
    --self.clientServerFindTree = winch.clientServerFindTree;
    
    local w = {};
	
	
    w.workingRadius = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.winch#workingRadius"), 50);
    w.isOn2 = false;
    
    w.attacherNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.winch#attacherNode"));
    w.attacherCompIndex = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.winch#attacherComponent"), 1);
    
    setMass(self.components[w.attacherCompIndex].node, 0.8);
    
    
    w.rope = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.winch#rope"));
    setVisibility(w.rope, false);
    
    w.speed = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.winch#speed"), 1)*0.0005;
    
    local speedX = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.winch.reel#speedX"), nil);
    if speedX ~= nil then
        w.reel = {};
        w.reel.speedX = speedX;
        w.reel.speedY = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.winch.reel#speedY"), 0);
        w.reel.speedZ = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.winch.reel#speedZ"), 0);
        w.reel.index = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.winch.reel#index"));
    end;
    
    
    w.massTimer = false;
    w.massTimerMs = 0;
	
	-- FS17 fixes
	w.addForceCap = 1;
	
	-- FS17 additions
	
	-- sound
	if self.isClient then
	--    w.winchingSample = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.winch.winchingSound", nil, self.baseDirectory);
		w.winchingSoundId = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.winch#soundIndex"));
	    w.winchingSoundPlaying = false;
	    if w.winchingSoundId ~= nil then
	        setVisibility(w.winchingSoundId , false);
	    end	
	end;
	
	if self.isClient then
		w.winchingSample = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.winch.winchingSound", nil, self.baseDirectory, self.components[1].node);
		w.winchingSamplePitch = 1;
		w.winchingSampleLastPitch = 0;
		w.winchingSampleVolume = 1.5;
		w.winchingSampleLastVolume = 0;
	end;

	w.actualLoad = 0;
	w.baseLoad = 1;
    
    w.winching = false;
	
	-- first the attacher count +1, this is the index of the current attacher then
	self.winchUtilHelper.treeAttacherCount = self.winchUtilHelper.treeAttacherCount + 1;
	
	-- save the given index within the table for further access just in case
	w.treeAttacherCountIndex = self.winchUtilHelper.treeAttacherCount;
		
	-- table of this attacher is inserted in winchUtilHelper attacher table at the given index
	self.winchUtilHelper.treeAttacher[self.winchUtilHelper.treeAttacherCount] = w;
	
	
	-- now we have all attachers in this spezialiazion loaded.. so the local max count is updated
	self.localWUH_W.treeAttacherCountMax = self.winchUtilHelper.treeAttacherCount;
	
end;

function winch:delete()
	SoundUtil.deleteSample(self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax].winchingSample);
end;
function winch:mouseEvent(posX, posY, isDown, isUp, button)
end;
function winch:keyEvent(unicode, sym, modifier, isDown)
end;
function winch:onOff2(state, noEventSend)
    if state ~= self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax].isOn2 then
        self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax].isOn2 = state;
        winchOnOffEvent.sendEvent(self, state, noEventSend);
    end;
end;
function winch:clientServerSetWinching(state, noEventSend)
    if state ~= self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax].winching then
        self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax].winching = state;
        --print("SetWinching called");
        winchSetWinchingEvent.sendEvent(self, state, noEventSend);
    end;
end;

function winch:update(dt)    
    if self:getIsActiveForInput() then    
        if InputBinding.hasEvent(InputBinding.WINCH_ME_ACTIVATE) then
            if self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax].localAttachedSplit == nil then
                self:onOff2(not self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax].isOn2);
            end;
        end;
    end;
    
	-- bug fixing in FS17 --
	if self:getIsActive() then
		if self.isServer then
			if self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax].localAttachedSplit ~= nil then
				if not entityExists(self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax].localAttachedSplit) then -- split was deleted some way 
					local w = self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax];
					w.serverAttachedSplit = nil;    
					w.localAttachedSplit = nil;
					w.localSplitAttacherRef = nil;
					w.foundLocalSplit = nil;
					w.wUpdated = true;
					w.winching = false;
					setVisibility(w.rope, false); 
					print("Split doesn't exist anymore");
				end;
			end;
		end;
	end;
	
	-- FS17 feature addons.. sound
	
	self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax].actualLoad = 0;
	
    -- the new stuff... 29.06.2016
    if self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax].isOn2 then
		local w = self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax];
		
		-- all
		if g_languageSuffix == "_de" then
			renderText(0.001, 0.0016, 0.02, "Seilwinde aktiv!");
		else
			renderText(0.001, 0.0016, 0.02, "Winch active!");
		end;
		
		-- FS17 addition, sound:
		SoundUtil.play3DSample(w.winchingSample);
		SoundUtil.setSampleVolume(w.winchingSample, w.winchingSampleLastVolume);
		
		
		
        if w.localAttachedSplit ~= nil then 
			-- rope animation
            local x, y, z = getWorldTranslation(w.localSplitAttacherRef);
            local a, b, c = getWorldTranslation(w.rope);
            local dirX, dirY, dirZ = worldDirectionToLocal(getParent(w.attacherNode), x-a, y-b, z-c);
            local upx, upy, upz = 0,1,0;
            setDirection(w.rope, dirX, dirY, dirZ, upx, upy, upz);
            local distance = Utils.vector3Length(a-x, b-y, c-z);
            setScale(w.rope, 1, 1, distance);
            setVisibility(w.rope, true);
			
			local currentLoad = 0;
			
			-- server only
			if w.serverAttachedSplit ~= nil then
				--renderText(0.001, 0.5, 0.02, "Debug: tree orig. mass = "..tostring(w.splitBackupMass))
				--renderText(0.001, 0.45, 0.02, "Debug: tree new mass = "..tostring(getMass(w.localAttachedSplit)));
				if w.winching then -- 
					-- the actual winching using joint limits
					w.curLimit = math.max(0.1, w.curLimit - (w.speed*dt));
					setJointTranslationLimit(w.serverAttachedSplit, 2, true, -w.curLimit, w.curLimit)
					
					-- optional reel animation
					if w.reel ~= nil then
						rotate(w.reel.index, w.reel.speedX, w.reel.speedY, w.reel.speedZ);
					end;
					
					-- sound volume and pitch ramp up
					if w.winchingSampleLastVolume < w.winchingSampleVolume then
						w.winchingSampleLastVolume = math.min(w.winchingSampleLastVolume + 0.01*dt, w.winchingSampleVolume);
					end;
					if w.winchingSampleLastPitch < w.winchingSamplePitch then
						w.winchingSampleLastPitch = math.min(w.winchingSampleLastPitch + 0.02*dt, w.winchingSamplePitch);
					end;
					-- set sound volume and pitch
					SoundUtil.setSampleVolume(w.winchingSample, w.winchingSampleLastVolume);
					SoundUtil.setSamplePitch(w.winchingSample, w.winchingSampleLastPitch);
					
					currentLoad = w.baseLoad; -- additional load calculation for further possibilities
					
					
				else
					-- sound volume and pitch ramp down
					if w.winchingSampleLastVolume > 0 then
						w.winchingSampleLastVolume = math.max(w.winchingSampleLastVolume - 0.01*dt, 0);
					end;
					if w.winchingSampleLastPitch > 0 then
						w.winchingSampleLastPitch = math.max(w.winchingSampleLastPitch - 0.02*dt, 0);
					end;	
					-- set sound volume and pitch					
					SoundUtil.setSampleVolume(w.winchingSample, w.winchingSampleLastVolume);
					SoundUtil.setSamplePitch(w.winchingSample, w.winchingSampleLastPitch);
				
				end;
				
				
				-- FS17 Fix, add additional force to winch the tree since the Joints are.. meh.
				local aX, aY, aZ = getWorldTranslation(w.attacherNode);
				local actualDistance = Utils.vector3Length(x-aX, y-aY, z-aZ);
				if actualDistance > w.curLimit then -- if actual distance is longer than joint limit the joint is failing..
					-- the difference between actual distance and supposed to be distance are used to calculate the force needed
					local difference = actualDistance - w.curLimit;
					local force = (1 * difference);
					--renderText(0.1, 0.1, 0.02, "raw: "..tostring(force));
					force = math.min(force, w.addForceCap);
					--renderText(0.1, 0.12, 0.02, "cap: "..tostring(force));
					
					currentLoad = currentLoad + force; -- again, load calculations 
					
					-- adjusting the pitch to the "load" of the winch according to the force needed 
					local pitch = w.winchingSampleLastPitch - force;
					SoundUtil.setSamplePitch(w.winchingSample, pitch);
					
					-- direction stuff:
					-- attacher split ref is x, y, z
					-- attaher node ref is aX, aY, aZ
					-- local direction relative to attacher split ref is:
					local dirX2 = aX - x;
					local dirY2 = aY - y;
					local dirZ2 = aZ - z;
					
					-- debug
					local ddx, ddy, ddz = localDirectionToLocal(w.localSplitAttacherRef, w.localAttachedSplit, dirX2/2, dirY2/2, dirZ2/2);
					
					local wx, wy, wz = localToWorld(w.localAttachedSplit, ddx, ddy, ddz)
					
					--drawDebugPoint(wx, wy, wz, 1, 0, 0, 1);	
					--drawDebugArrow(x, y, z, dirX2, dirY2, dirZ2, 0, 0, 1, 1, 0, 0);
					
					-- debug end
					
					-- add the force to the tree
					addForce(w.localAttachedSplit, dirX2*force,dirY2*force,dirZ2*force, x,y,z, false);
					
				elseif actualDistance <= w.curLimit then -- if actual distance is smaller than joint limit the tree jumped ahead.
					-- currently only used for sound calculation, could be used to calculate rope slack if shader based rope is used.. Not yet.
					local difference = w.curLimit - actualDistance;
					local loadDecrease = math.max(-(1 * difference), -1);
					currentLoad = currentLoad + loadDecrease;
					local pitch = w.winchingSampleLastPitch - loadDecrease;
					SoundUtil.setSamplePitch(w.winchingSample, pitch);
				end;
			end;
			
			w.actualLoad = currentLoad;
        else
			w.winchingSampleLastVolume = 0; -- if there is no split attached, no reason to make sound
		end;
        
		-- increasing mass of rope component during ataching period, not sure if still needed for stable operation
        if w.massTimer then
            w.massTimerMs = w.massTimerMs + dt;
            if w.massTimerMs > 1000 then
                w.massTimer = false;
                w.massTimerMs = 0;
                -- set rope component mass back to normal
                setMass(self.components[w.attacherCompIndex].node, 0.8);
                --print("Mass Timer reset")
            end;
        end;
        
        -- individual player
        if g_currentMission.controlPlayer and g_currentMission.player ~= nil then
            -- get the distance from the player to the winch to check if the player is within the length of the rope
            local x,y,z = getWorldTranslation(g_currentMission.player.rootNode);
            local a,b,c = getWorldTranslation(self.rootNode)
            local distance = Utils.vector3Length(x-a, y-b, z-c);
            if distance < w.workingRadius then -- player is in attaching range
			
				if g_languageSuffix == "_de" then
					renderText(0.08, 0.0016, 0.02, "Abstand zur Winde: "..tostring(math.floor(distance)).." Meter");
				else
					renderText(0.08, 0.0016, 0.02, "distance to winch: "..tostring(math.floor(distance)).." meters");
				end;
				
				-- only on first update frame:
                if self.firstTimeActiveWinch == nil then -- add the search plane to player
                    w.searchNodes = {};
                    w.searchNodes.center = createTransformGroup("centerNode");
                    link(g_currentMission.player.cameraNode, w.searchNodes.center);
                    setTranslation(w.searchNodes.center, 0, 0, -1);
                    local planePoint, dir1, dir2 = winchUtil:createFinderShape(w.searchNodes.center);
                    w.searchNodes.planePoint = planePoint;
                    w.searchNodes.dir1 = dir1;
                    w.searchNodes.dir2 = dir2;
                    self.firstTimeActiveWinch = true;
                end;
				
                -- draw center point debug point
                local dX, dY, dZ = getWorldTranslation(w.searchNodes.center);
                drawDebugPoint(dX,dY,dZ,1,0.5,1,1);
                
                -- find trees...
                local pX, pY, pZ = getWorldTranslation(w.searchNodes.planePoint);
                local dir1X, dir1Y, dir1Z = getWorldTranslation(w.searchNodes.dir1);
                local dir2X, dir2Y, dir2Z = getWorldTranslation(w.searchNodes.dir2);

                local nx, ny, nz, yx, yy, yz = dir1X-pX, dir1Y-pY, dir1Z-pZ, dir2X-pX, dir2Y-pY, dir2Z-pZ;
                
                local shape, minY, maxY, minZ, maxZ = findSplitShape(pX,pY,pZ, nx, ny, nz, yx, yy, yz, 1, 1);
                if shape ~= nil and shape ~= 0 then -- found split shape
                    w.currentLocalSplit = shape;
                    w.currentLocalSplitSizes = {minY, maxY, minZ, maxZ};
                    
                    if w.localAttachedSplit == nil then
					
						if g_languageSuffix == "_de" then
							renderText(0.3, 0.0016, 0.02, "Baum gefunden. Taste N zum anhängen");
						else
							renderText(0.3, 0.0016, 0.02, "Tree in Range. Press N to attach");
						end;
						
                        if w.wUpdated == nil and InputBinding.hasEvent(InputBinding.WINCH_ME_ATTACH) then -- attach log
                            --print("WINCH_ATTACH_INPUT_CALL")
                            local tX, tY, tZ = getWorldTranslation(w.searchNodes.center);
                            local rX, rY, rZ = getWorldRotation(w.searchNodes.center);
                            
                            -- loop placement (and attacher placement relative to that) data
                            local lA, lB, lC = localToWorld(w.searchNodes.planePoint, 0, (minY+maxY)*0.5, (minZ+maxZ)*0.5)
                            local scaleY = maxY-minY;
                            local scaleZ = maxZ-minZ;
                            
                            winchUtil:clientServerFindTree(self, w.treeAttacherCountIndex,  tX, tY, tZ, rX, rY, rZ, true, nil, lA, lB, lC, scaleY, scaleZ);
                            --print("WINCH_ATTACH_INPUT_CALL_control")
                        end;
                    end;
                else    
                    w.currentLocalSplit = nil;
                end;
                -- check if winching is enabled
                if w.localAttachedSplit ~= nil then
				
					if g_languageSuffix == "_de" then
						renderText(0.3, 0.0016, 0.02, "Baum angehängt. Taste M: Abhängen, Taste K gedrückt halten: winden");
					else
						renderText(0.3, 0.0016, 0.02, "Tree attached. Press M to detach, Hold K to winch the tree.");
					end;
					
                    if InputBinding.isPressed(InputBinding.WINCH_ME_WINCHING) then
                        self:clientServerSetWinching(true);
                    else
                        self:clientServerSetWinching(false);
                    end;
                    -- check if detaching is enabled, detachTree
                    if w.wUpdated == nil and InputBinding.hasEvent(InputBinding.WINCH_ME_DETACH) then
                        winchUtil:clientServerDetachTree(self, w.treeAttacherCountIndex);
                        --print("WINCH_DETACH_INPUT_CALL");
                    end;    
                end;
            end;
        end;
        w.wUpdated = nil;
    else
		SoundUtil.stop3DSample(self.winchUtilHelper.treeAttacher[self.localWUH_W.treeAttacherCountMax].winchingSample);
	end;
end;    


function winch:draw()
    if self:getIsActiveForInput() then
        g_currentMission:addHelpButtonText(g_i18n:getText("WINCH_ME_ACTIVATE"), InputBinding.WINCH_ME_ACTIVATE);
    end;
end;
                

              
-- OnOff Event
winchOnOffEvent = {};
winchOnOffEvent_mt = Class(winchOnOffEvent, Event);

InitEventClass(winchOnOffEvent, "winchOnOffEvent");

function winchOnOffEvent:emptyNew()
    local self = Event:new(winchOnOffEvent_mt);
    return self;
end;

function winchOnOffEvent:new(object, state)
    local self = winchOnOffEvent:emptyNew();
    self.object = object;
    self.state = state;
    return self;
end;

function winchOnOffEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.object = networkGetObject(id);
    self.state = streamReadBool(streamId);
    self:run(connection);
end;

function winchOnOffEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteBool(streamId, self.state);
end;

function winchOnOffEvent:run(connection)
    self.object:onOff2(self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(winchOnOffEvent:new(self.object, self.state), nil, connection, self.object);
    end;
end;

function winchOnOffEvent.sendEvent(object, state, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(winchOnOffEvent:new(object, state), nil, nil, object);
        else
            g_client:getServerConnection():sendEvent(winchOnOffEvent:new(object, state));
        end;
    end;
end;
                
                
-- setWinching Event
winchSetWinchingEvent = {};
winchSetWinchingEvent_mt = Class(winchSetWinchingEvent, Event);

InitEventClass(winchSetWinchingEvent, "winchSetWinchingEvent");

function winchSetWinchingEvent:emptyNew()
    local self = Event:new(winchSetWinchingEvent_mt);
    return self;
end;

function winchSetWinchingEvent:new(object, state)
    local self = winchSetWinchingEvent:emptyNew();
    self.object = object;
    self.state = state;
    return self;
end;

function winchSetWinchingEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.object = networkGetObject(id);
    self.state = streamReadBool(streamId);
    self:run(connection);
end;

function winchSetWinchingEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteBool(streamId, self.state);
end;

function winchSetWinchingEvent:run(connection)
    self.object:clientServerSetWinching(self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(winchSetWinchingEvent:new(self.object, self.state), nil, connection, self.object);
    end;
end;

function winchSetWinchingEvent.sendEvent(object, state, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(winchSetWinchingEvent:new(object, state), nil, nil, object);
        else
            g_client:getServerConnection():sendEvent(winchSetWinchingEvent:new(object, state));
        end;
    end;
end;                
                
